//	WinDjView
//	Copyright (C) 2004-2006 Andrew Zhezherun
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	http://www.gnu.org/copyleft/gpl.html

// $Id:$

#include "Global.h"


void Observable::AddObserver(Observer* observer)
{
	m_observers.insert(observer);
}

void Observable::RemoveObserver(Observer* observer)
{
	m_observers.erase(observer);
}

void Observable::UpdateObservers(const Message& message)
{
	for (std::set<Observer*>::iterator it = m_observers.begin(); it != m_observers.end(); ++it)
	{
		Observer* observer = *it;
		observer->OnUpdate(this, &message);
	}
}
